# Copyright (c) 2025 GVEC Contributors, Max Planck Institute for Plasma Physics
# License: MIT
"""pyGVEC: A Python interface for the GVEC code."""

# _version.py is generated by setuptools_scm
from ._version import __version__, __version_tuple__

# primary classes and functions

from .state import State
from .comp import compute, Evaluations, EvaluationsBoozer, EvaluationsBoozerCustom
from .run import run

# submodules

from . import comp, fourier, quantities, scripts, state, surface, util
